package readerwriter;

/**
 * <p>Title:        ReaderWriter
 * <p>Description:  Progettazione di un mini framework per la gestione generale
 * di risorse condivise in maniera concorrente in lettura/scrittura
 *
 * <p>Copyright:    Copyright (c) 2001
 * <p>Company:      Universita' degli studi di Milano (Facolta' di Informatica)
 *
 * @author Gabriele "SunGray" Lana
 * @version 1.0
 */

/**
 * L'interfaccia ThreadSelector, dichiara i metodi di base di quelle che saranno le classi
 * concrete che definiranno le politiche di risveglio dei thread
 */

public interface ThreadSelector
{
  /**
   * Inserisce un nuovo Thread nella lista dei Thread in attesa; si preoccupa di metterlo
   * in wait dopo aver liberato tutte le chiavi di semafori di cui era in possesso
   *
   * @param threadRw Thread corrente che deve essere aggiunto nella lista dei thread in attesa
   * @param priority oggetto generico che definisce la priorita' da assegnare al Thread aggiunto
   */
  public void addThread(SemaphoredThread threadRW, Object priority);

  /**
   * Rimuove un appropriato Thread dalla lista dei Thread in attesa; si preoccupa di
   * risvegliare il Thread dal suo stato di wait
   *
   * @return Thread Il thread che e' stato risvegliato, null se non ne esistono
   */
  public SemaphoredThread removeThread();


}